/*
/--------------------------------------------------------------------
|
|      $Id: FilterContrast.h,v 1.1 2000/11/06 23:20:22 uzadow Exp $
|
|      Copyright (c) 1996-1998 Ulrich von Zadow
|
\--------------------------------------------------------------------
*/

#if !defined(INCL_FILTERCONTRAST)
#define INCL_FILTERCONTRAST

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Filter.h"

class CBmp;

//! Enhances or reduces the image contrast using a linear mapping 
//! between input and output. The zero point (i. e., the intensity 
//! that is neither enhanced nor reduced) has to be provided.
class CFilterContrast : public CFilter  
{
public:
  //! contrast is the slope of the function. offset is the intensity
  //! at which the color stays the same. With offset 128 and contrast
  //! 1, the image stays unchanged.
	CFilterContrast(double contrast, 
                  BYTE offset);
	virtual ~CFilterContrast();
  virtual void Apply(CBmp *pBmpSource, CBmp* pBmpDest);

protected:
  double m_contrast;
  double m_offset;
};
#endif

/*
/--------------------------------------------------------------------
|
|      $Log: FilterContrast.h,v $
|      Revision 1.1  2000/11/06 23:20:22  uzadow
|      Added Contrast, Intensity and Lightness filters by
|      Thomas Hirschmann
|
|
\--------------------------------------------------------------------
*/
