/*
/--------------------------------------------------------------------
|
|      $Id: VideoInvertFilter.cpp,v 1.2 2000/10/12 21:56:12 uzadow Exp $
|
|      Copyright (c) 1996-1998 Ulrich von Zadow
|
\--------------------------------------------------------------------
*/

#include "stdpch.h"
#include "Filter.h"
#include "VideoInvertFilter.h"
#include "bitmap.h"
#include "hsvconvert.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


CVideoInvertFilter::CVideoInvertFilter()
{

}

CVideoInvertFilter::~CVideoInvertFilter()
{

}

double CVideoInvertFilter::Filter(double dVal)
{
	return 0;
}


void CVideoInvertFilter::Apply(CBmp *pBmpSource, CBmp *pBmpDest)
{
  // Only works for 32 bpp bitmaps at the moment.
  PLASSERT (pBmpSource->GetBitsPerPixel() == 32);

  pBmpDest->Create (pBmpSource->GetWidth(), pBmpSource->GetHeight(), 32, FALSE);
  BYTE ** pSrcLines = pBmpSource->GetLineArray();
  BYTE ** pDstLines = pBmpDest->GetLineArray();

  for (int y = 0; y<pBmpDest->GetHeight(); ++y)
  { // For each line
    BYTE * pSrcPixel = pSrcLines[y];
    BYTE * pDstPixel = pDstLines[y];

    for (int x = 0; x < pBmpDest->GetWidth(); ++x)
    { // For each pixel
      double v1, v2, v3;

      v1 = (double)pSrcPixel[RGBA_RED];
      v2 = (double)pSrcPixel[RGBA_GREEN];
      v3 = (double)pSrcPixel[RGBA_BLUE];

      fp_rgb_to_hsv(&v1, &v2, &v3);
      v3 = 255.0-v3;
      fp_hsv_to_rgb(&v1, &v2, &v3);

      *pDstPixel = (int)v3;
	  pDstPixel++;
      *pDstPixel = (int)v2;
	  pDstPixel++;
      *pDstPixel = (int)v1;
	  pDstPixel++;

	  pDstPixel++;

	  /*BYTE (pSrcPixel[RGBA_RED]*0.212671+
	                       pSrcPixel[RGBA_GREEN]*0.715160+
                         pSrcPixel[RGBA_BLUE]*0.072169);*/
	    pSrcPixel += sizeof(RGBAPIXEL);
    }
  }

}

/*
/--------------------------------------------------------------------
|
|      $Log: VideoInvertFilter.cpp,v $
|      Revision 1.2  2000/10/12 21:56:12  uzadow
|      Moved local functions from VideoInvertFilter.cpp to
|      hsvconvert.*
|
|      Revision 1.1  2000/03/31 12:20:06  Ulrich von Zadow
|      Video invert filter (beta)
|
|
|
\--------------------------------------------------------------------
*/
