/*
/--------------------------------------------------------------------
|
|      $id$
|
|      Copyright (c) 1996-1998 Ulrich von Zadow
|
\--------------------------------------------------------------------
*/

#ifndef __PICTUREDECODER_H_
#define __PICTUREDECODER_H_

#include "resource.h"       // main symbols
#include "anydec.h"
#include "winbmp.h"
#include "except.h"
#include "streamsink.h"

extern CComModule _Module;

/////////////////////////////////////////////////////////////////////////////
// CPictureDecoder
class ATL_NO_VTABLE CPictureDecoder : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CPictureDecoder, &CLSID_PictureDecoder>,
	public ISupportErrorInfo,
	public IDispatchImpl<IPictureDecoder, &IID_IPictureDecoder, &LIBID_PAINTXLib>
{
public:
	CPictureDecoder()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_PICTUREDECODER)

BEGIN_COM_MAP(CPictureDecoder)
	COM_INTERFACE_ENTRY(IPictureDecoder)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// PictureDecoder
public:
	STDMETHOD(LoadResPicture)(/*[in]*/ int ResourceID, /*[out, retval]*/ IUnknown ** ppUnk);
	STDMETHOD(LoadPicture)(/*[in]*/ BSTR Filename, /*[out, retval]*/ IUnknown ** ppUnk);
protected:
  IPictureDisp * BitmapToPicture(CBmp* pBmp);
	HRESULT SignalPictureChanged(IUnknown * pUnknown);
	HRESULT CreateErrorInfo(CTextException  TextException,REFIID riidSource);
	CAnyPicDecoder m_AnyPicDecoder;
};

#endif //__PICTUREDECODER_H_
/*
/--------------------------------------------------------------------
|
|      $log$
|
--------------------------------------------------------------------
*/
